#define S_INACTIVE      0
#define S_CONNECTING    1
#define S_INFO          2
#define S_DOWNLOADING   3
#define S_CANCELED      4
#define S_FINISHED      5
#define S_TIMEOUT       6
#define S_REJECT        7
#define S_INCOMPLETE    8
#define S_UPLOADING     9
#define S_INFO1        10
#define S_INFO2        11
#define S_INFO3        12
#define S_WAITING      13
#define S_FIREWALL     14
#define S_CONERROR     15
#define S_QUEUED       16
#define S_REMOTE       17
#define S_UNAVAILABLE  18

#define T_UNKNOWN       0
#define T_DOWNLOAD      1
#define T_UPLOAD        2

transfer_t* transfer_new();
int transfer_is_active(transfer_t* transfer);

file_t* lib_search_transfer(transfer_t* transfer);

void download_file(file_t* file);
void cmd_download_ack(char* data);
void cmd_upload_request(char* data);
void cmd_alternate_ack(char* data);

transfer_t* transfer_is_in_download(char* user, char* longname);
transfer_t* transfer_is_in_upload(char* user, char* longname);
int transfer_update(transfer_t* transfer);

void transfer_insert_download(transfer_t *transfer);
void transfer_insert_upload(transfer_t *transfer);

int connect_to_user(transfer_t* transfer);
void cmd_get_error(char* data);
void cmd_remote_queued(char* data);
int download_inspector(gpointer data);
void cmd_linkspeed_response(char* data);

FILE* open_download_file(transfer_t* transfer);
FILE* open_upload_file(transfer_t* transfer);

void transfer_end(transfer_t* transfer, int mode);

gint outgoing_header(gpointer data, gint source,
		 GdkInputCondition condition);
gint incoming_header(gpointer data, gint source, 
		     GdkInputCondition condition);
gint upload_push_output(gpointer data, gint source, 
			GdkInputCondition condition);
gint download_get_input(gpointer data, gint source, 
			GdkInputCondition condition);

void destroy_transfer_row(gpointer data);
int transfer_timeout_cb(gpointer data);

